- name: Change database user {{ database_user }}'s password and user rights
  postgresql_user:
    login_host=localhost
    name={{ database_user }}
    password={{ database_password }}
    state=present
    role_attr_flags=NOCREATEDB,NOSUPERUSER,LOGIN
    login_password={{ database_password_postgres }}
  become: yes
  become_user: postgres

- name: Create database reporting user {{ database_reporting_user }}
  postgresql_user:
    login_host=localhost
    name={{ database_reporting_user }}
    password={{ database_reporting_user_password }}
    state=present
    login_password={{ database_password_postgres }}
  become: yes
  become_user: postgres


- name: drop all public access rights to {{ database_name }} database
  postgresql_privs:
    login_host=localhost
    database={{ database_name }}
    state=absent
    roles=PUBLIC
    privs=ALL
    type=database
    login_password={{ database_password_postgres }}
  become: yes
  become_user: postgres

- name: add all access rights to {{ database_name }} database for {{ database_user }} user
  postgresql_privs:
    host=localhost
    database={{ database_name }}
    roles={{ database_user }}
    state=present
    privs=ALL
    type=database
    grant_option=yes
    login_password={{ database_password_postgres }}
  become: yes
  become_user: postgres

- name: Grant connect to {{ database_name }} for user {{ database_reporting_user }}
  postgresql_privs:
    host=localhost
    database={{ database_name }}
    roles={{ database_reporting_user }}
    state=present
    privs=CONNECT
    type=database
    login_password={{ database_password_postgres }}
  become: yes
  become_user: postgres

- name: Set shared buffer
  postgresql_set:
    login_host=localhost
    login_password={{ database_password_postgres }}
    name=shared_buffers
    value={{ shared_buffers_memory }}
  register: set
  become: yes
  become_user: postgres

- name: Enable login collector
  postgresql_set:
    login_host=localhost
    login_password={{ database_password_postgres }}
    name=logging_collector
    value=on
  register: set
  become: yes
  become_user: postgres

- name: Log only queries that takes 500ms or longer
  postgresql_set:
    login_host=localhost
    login_password={{ database_password_postgres }}
    name=log_min_duration_statement
    value=500
  register: set
  become: yes
  become_user: postgres

- name: Restart a container
  docker_container:
    name: "{{ database_container_name }}"
    state: started
    restart: true
  become: yes

- name: wait for Postgresql complete restart
  postgresql_ping:
    login_host: localhost
    port: 5432
    login_user: postgres
    login_password: "{{ database_password_postgres }}"
  register: result
  until: result.is_available
  retries: 30
  delay: 4
  become: yes
